function [ind] = com_pop(state,params,allind) 

    if isempty(state.archive)
        val_x          = [allind.parameter];
        val_y          = [allind.objective];
        val_cv         = [allind.cv];
        val_f          = [allind.objective;allind.cv];
    else
        val_x          = [allind.parameter];
        val_y          = [allind.objective];
        val_cv         = [allind.cv];
        val_f          = [allind.objective;allind.cv];
    end    

    [x,fit,fit_obj] = new_ndsort(val_x',val_f',val_y',val_cv');
    val_x = x; val_y = fit_obj; val_cv = fit(:,end-2);
    
    cellpoints_x    = num2cell(val_x', 1);
    cellpoints_y    = num2cell(val_y', 1);
    cellpoints_cv   = num2cell(val_cv', 1);
    indiv           = get_structure('individual');
    ind             = repmat(indiv, [1, params.popsize]);
    [ind.parameter] = cellpoints_x{:};
    [ind.objective] = cellpoints_y{:};
    [ind.cv]        = cellpoints_cv{:};
    
end

