%% Ժ
clear; close; clc;
name_func = {'LIRCMOP1','LIRCMOP2','LIRCMOP3','LIRCMOP4','LIRCMOP5','LIRCMOP6','LIRCMOP7','LIRCMOP8','LIRCMOP9','LIRCMOP10','LIRCMOP11','LIRCMOP12','LIRCMOP13','LIRCMOP14'};
% name_func = {'CF1','CF2','CF3','CF4','CF5','CF6','CF7','CF8','CF9','CF10'};
% name_func = {'DASBCMOP1','DASBCMOP2','DASBCMOP3','DASBCMOP4','DASBCMOP5','DASBCMOP6','DASBCMOP7'};
%% 㷨ʼ
for seq = 7%:length(name_func)                                                         % choose operatianal problems set
    for nrun=1%:30                                                      % running times
        Pushstage    = 1 ;
        Pullstage    = 0 ;
        name_f                 = char(name_func(seq));                 % choose the number of problems
        %seed                   = 60+nrun;%randn('state',seed);rand('state',seed);
        state                  = get_structure( 'state');
        params                 = get_structure( 'parameter');
        [params,mop,pop]       = inputparams(name_f,params);           % input parameter
        [params,mop,pop,state,max_cv,epsilon_] = initialize(params,mop,pop,state,Pushstage,Pullstage);
        
        %------------------------- תʼ-------------------
        epsilon      = 1e-3;                                           % 仯
        l_           = 30;                                             % 
        changeRate   = 1.0;                                            % l_֮ǰı任
        sizeAll      = [];
        recordData   = [];
        %------------------- EpsilonԼƣʼ--------------
        Tc           = 0.9 * params.iteration;  %0.8    0.7
        tau          = 0.05;              %0.05
        alpha        = 0.95;              %0.95
        %---------------------- ʼarchive ------------------
        population   = [pop.inter];
        arch_x       = [population.parameter];
        arch_y       = [population.objective];
        arch_cv      = [population.cv];
        population   = [arch_x',arch_y',arch_cv'];
        fea  = (population(:,end) == 0);
        arch = archive(population(fea,:),population,params.popsize,mop.od);
        
        while state.stopCriterion
            
            if state.currentGen  < 0.9 * params.maxgen
                %------------------------- ת    --------------------
                gen                    = state.currentGen - 1;
                class                  = [];
                if Pushstage == 1 && Pullstage == 0
                    [Pushstage,Pullstage]  = transition(gen,l_,epsilon,recordData,state);
                    disp('Run Push Stage');
                else
                    disp('Run Pull Stage');
                end
                %----------------------------------------------------------
                [params,mop,pop,state,max_cv,percent] = evolution(params,mop,pop,state,Pushstage,Pullstage,epsilon_,max_cv);
                
                sizeAll            = save_data(pop,params);
                recordData         = [recordData;sizeAll];
                % ǰ״̬
                state         = stateOutput(state,params,pop,mop,nrun);
                
                population   = [pop.inter];
                arch_x       = [population.parameter];
                arch_y       = [population.objective];
                arch_cv      = [population.cv];
                population   = [arch_x',arch_y',arch_cv'];
                arch         = archive(arch,population,params.popsize,mop.od);
                
            elseif state.currentGen  == 0.9 * params.maxgen
                individual     = [pop.inter];
                val_x          = [individual.parameter];
                val_y          = [individual.objective];
                val_cv         = [individual.cv];
                cellpoints_x    = num2cell(val_x, 1);
                cellpoints_y    = num2cell(val_y, 1);
                cellpoints_cv   = num2cell(val_cv, 1);
                indiv           = get_structure('individual');
                pop_             = repmat(indiv, [1, params.popsize]);
                [pop_.parameter] = cellpoints_x{:};
                [pop_.objective] = cellpoints_y{:};
                [pop_.cv]        = cellpoints_cv{:};
                [params,mop,pop_,state,max_cv,percent] = evolution_(params,mop,pop_,state,epsilon_,max_cv);
                
                state                  = stateOutput_(state,params,pop_,mop,nrun);
                
                arch_x       = [pop_(1:end).parameter];
                arch_y       = [pop_(1:end).objective];
                arch_cv      = [pop_(1:end).cv];
                population   = [arch_x',arch_y',arch_cv'];
                arch         = archive(arch,population,params.popsize,mop.od);
                
            else
                [params,mop,pop_,state,max_cv,percent] = evolution_(params,mop,pop_,state,epsilon_,max_cv);
                
                state                  = stateOutput_(state,params,pop_,mop,nrun);
                
                arch_x       = [pop_(1:end).parameter];
                arch_y       = [pop_(1:end).objective];
                arch_cv      = [pop_(1:end).cv];
                population   = [arch_x',arch_y',arch_cv'];
                arch         = archive(arch,population,params.popsize,mop.od);
            end
            
            [epsilon_]             = update_epsilon(epsilon_,percent,alpha,tau,Tc,state.reg_obj,max_cv);
            
            fprintf('num =   %d',nrun);
            fprintf(' gen =   %d\n',state.currentGen);
            
            state.currentGen       = state.currentGen+1;
            % Ƿֹ
            state                  = checkstop(params,state);
        end
        
        population       = arch;
        [popsize,~]      = size(population);
        cellpoints_x     = num2cell(population(:,1:1:mop.pd)', 1);
        cellpoints_y     = num2cell(population(:,mop.pd+1:1:mop.pd+mop.od)',1);
        cellpoints_cv    = num2cell(population(:,end)',1);
        indiv            = get_structure('individual');
        pop_             = repmat(indiv, [1, popsize]);
        [pop_.parameter] = cellpoints_x{:};
        [pop_.objective] = cellpoints_y{:};
        [pop_.cv]        = cellpoints_cv{:};
        
        state = stateOutput_(state,params,pop_,mop,nrun);
    end
end




