function str = get_structure( name )
switch name 
    % state: optimization state of one generation
    case 'state'
        str = struct(...
          'currentGen', 1,...             % current generation number
          'reg_obj', 0,...                % number of objective function evaluation
          'totalTime', 0,...              % total time from the beginning
          'stopCriterion',1,...           % ֹ
          'val_IGD',[],...                % IGDֵ
          'val_H',[],...                  % ǰHֵ 
          'archive',[]);                  % Ӣ              
      
    case 'individual' 
        str = struct(...
            ...%%%%%%%%%%%%%%%%%%%%%%%%%%%ʽĲ
            'parameter',[],...            % parameterԱ
            'objective',[],...            % objectiveĿ꺯 
            ...%%%%%%%%%%%%%%%%%%%%%%%%%%%˽вض㷨
            ...%%%%%%%%%%%%%%%%%֧ϵ㷨
            'rank',[],...                 % rank֧õ
            'distance',[],...             % ӵ룬֧㷨õ
            ...%%%%%%%%%%%%%%%%ָ㷨
            'inValue',[],...
            'c',[],...
            'cv',[]);                     % ֵָ           

    case 'parameter'
        str = struct(...
            ...%%%%%%%%%%%%%%%%%%%%%%%%%%%в
            'popsize',[],...              % popsizeȺģ
            'maxgen',[],...               % maxgen
            'isCauIGD','yes',...          % ǷIGD
            'isDebug',1,...               % Ƿǵ԰汾10
            'resultOut','save',...        % ʽǱ滹ʾ
            'iteration',[],...            % iterationĿ꺯ļ
            'PFStar',[],...               % Чʵľȷֲĵ
            'isCauH','yes',...            % ǷHֵ 
            'useArchive','no',...         % ǷԾӢд浵
            ...%%%%%%%%%%%%%%%%%%%%%%%%%%%˽в
            ...%%%%%%%%%%%%ͲмĲ
            'num_class',[],...            % num_classĿ
            ...%%%%%%%%%%%%ӽֵĲ
            'pmuta',[],...                % pmutaĸʣ
            'delta',[],...                % deltaӽʱģ˻ӣ
            'selectPro',0.7,...           % ôѡӽĸ壬ڷ㷨õ 
            ...%%%%%%%%%%%%ѡõĲ
            'selectMethod','NS',...       % ѡʽNSnsga-IIѡʽ
            ...                           %'WS'ȨѡʽMMСѡʽ
            ...                           % 'VEGAvegaѡʽ
            ...%%%%%%%%%%%%ڻȨѡ㷨õȨز
            'idealmin',[],...             % ĿǰΪֵֹСֵ
            'useWeight','yes',...         % ǷҪȨ
            'weight',[],...               % ӦȨ
            ...%%%%%%%%%%%hypeõĲ
            'reference',[]);              % H-valueʱõĲο          
            
    case 'testmop'
         str = struct(...
             'name',[],...                % nameǲԺƣ
             'od',[],...                  % odĿ꺯ά
             'pd',[],...                  % pdԱά
             'domain',[],...              % domainԱȡֵΧ
             'func',[]);                  % funcǲԺ
                                        

    case 'subclass' 
        str = struct(...
            ...%%%%%%%%%%%%%%%%%%%%%%%%%%%в
            'center',[],...                % center
            'inter',[],...                 % interȺ
            'num_ind',[],...               % num_indȺĹģ
            ...%%%%%%%%%%%%%%%%%%%%%%%%%%%˽в
            ...%%%%%%%%%%%%%%ȨѡӵȨز
            'weight',[]);                  % ÿȺȨ
      
        
    otherwise
        error('the structure name requried does not exist!');

end