function [params,mop,pop,state,max_cv,epsilon_]= initialize(params,mop,pop,state,Pushstage,Pullstage)
    num_nod               = params.popsize;
    inds                  = randompoint(mop, num_nod);
    

    
    %% ÿһ
    [inds,state]          = evaluate(inds,mop,state);
    v                     = [inds.objective];
    params.idealmin       = min(v,[],2);

    N                     = length(inds);
    cv                    = [inds.c];
    cv                    = overall_cv(cv);
    cv                    = cv';  
   for i=1:N 
       [inds(i).cv] = cv(i);
   end

   temp_infea_cv = sort(cv,'descend');
   max_cv        = -1e30;
   if temp_infea_cv(1) > max_cv
        max_cv = temp_infea_cv(1);
   end
   
   if temp_infea_cv(0.2 * params.popsize)>1e-6
        epsilon_=temp_infea_cv(0.2 * params.popsize);
   else
        epsilon_=inf;
   end
   
    %% Ⱥʼ
    noval                 = v-repmat(params.idealmin,[1,num_nod]);
    team                  = group(params,pop,noval);
    for i=1:params.num_class
        num_p             = length(team{i});
        if num_p<=pop(i).num_ind
            tst                      = floor(num_nod*rand(1,pop(i).num_ind-num_p))+1;
            selind                   = inds([team{i},tst]);
            pop(i).inter             = selind;
        else
            selind                   = inds(team{i});
            pop(i).inter             = selection(params,selind,pop(i),Pushstage,Pullstage,epsilon_);
        end
    end 
    %% ʼӢ
    if ( strcmpi(params.useArchive, 'yes'))
        nspop           = ndsort(params,[pop.inter]);
        state.archive   = nspop([nspop.rank]==1); 
    end 
end


%% 
function ind = randompoint(prob, n)
    if (nargin==1)
        n=1;
    end
    randarray = rand(prob.pd, n);
    lowend = prob.domain(:,1);
    span = prob.domain(:,2)-lowend;
    point = randarray.*(span(:,ones(1, n)))+ lowend(:,ones(1,n));
    cellpoints = num2cell(point, 1);
    indiv = get_structure('individual');
    ind = repmat(indiv, [1, n]);
    [ind.parameter] = cellpoints{:};
end

