function [epsilon]=update_epsilon(epsilon,percent,alpha,tau,Tc,reg_obj, max_cv)
    if epsilon==inf && percent<1
        epsilon=max_cv;
    end
    if reg_obj<Tc
        if percent<alpha
            epsilon = (1-tau)*epsilon;
        else
            epsilon=(1+tau)*max_cv;
        end
    else
        epsilon=0;
    end
end